/* cdwDataset.c was originally generated by the autoSql program, which also 
 * generated cdwDataset.h and cdwDataset.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "cdwDataset.h"



char *cdwDatasetCommaSepFieldNames = "name,label,description,pmid,pmcid";

void cdwDatasetStaticLoad(char **row, struct cdwDataset *ret)
/* Load a row from cdwDataset table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->name = row[0];
ret->label = row[1];
ret->description = row[2];
ret->pmid = row[3];
ret->pmcid = row[4];
}

struct cdwDataset *cdwDatasetLoad(char **row)
/* Load a cdwDataset from row fetched with select * from cdwDataset
 * from database.  Dispose of this with cdwDatasetFree(). */
{
struct cdwDataset *ret;

AllocVar(ret);
ret->name = cloneString(row[0]);
ret->label = cloneString(row[1]);
ret->description = cloneString(row[2]);
ret->pmid = cloneString(row[3]);
ret->pmcid = cloneString(row[4]);
return ret;
}

struct cdwDataset *cdwDatasetLoadAll(char *fileName) 
/* Load all cdwDataset from a whitespace-separated file.
 * Dispose of this with cdwDatasetFreeList(). */
{
struct cdwDataset *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[5];

while (lineFileRow(lf, row))
    {
    el = cdwDatasetLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct cdwDataset *cdwDatasetLoadAllByChar(char *fileName, char chopper) 
/* Load all cdwDataset from a chopper separated file.
 * Dispose of this with cdwDatasetFreeList(). */
{
struct cdwDataset *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[5];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = cdwDatasetLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct cdwDataset *cdwDatasetCommaIn(char **pS, struct cdwDataset *ret)
/* Create a cdwDataset out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new cdwDataset */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->name = sqlStringComma(&s);
ret->label = sqlStringComma(&s);
ret->description = sqlStringComma(&s);
ret->pmid = sqlStringComma(&s);
ret->pmcid = sqlStringComma(&s);
*pS = s;
return ret;
}

void cdwDatasetFree(struct cdwDataset **pEl)
/* Free a single dynamically allocated cdwDataset such as created
 * with cdwDatasetLoad(). */
{
struct cdwDataset *el;

if ((el = *pEl) == NULL) return;
freeMem(el->name);
freeMem(el->label);
freeMem(el->description);
freeMem(el->pmid);
freeMem(el->pmcid);
freez(pEl);
}

void cdwDatasetFreeList(struct cdwDataset **pList)
/* Free a list of dynamically allocated cdwDataset's */
{
struct cdwDataset *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    cdwDatasetFree(&el);
    }
*pList = NULL;
}

void cdwDatasetOutput(struct cdwDataset *el, FILE *f, char sep, char lastSep) 
/* Print out cdwDataset.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->label);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->description);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->pmid);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->pmcid);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

